#include <cstdlib>
#include <dlfcn.h>
#include <iostream>

typedef char * (*fonctionQuery) (void);
typedef int (*fonctionRun) (void);

int
main(int argc, char *argv[]) {
#if __GNUC__ == 3 // gcc 3.x
    void *handle = dlopen("./Affichage.plg", RTLD_NOW | RTLD_GLOBAL);
#else
    void *handle = dlopen("./Affichage.plg", RTLD_NOW);
#endif

    if (! handle) {
	cerr << "Bibliothque non trouve\n";
	return EXIT_FAILURE;
    }

    // Enregistrement du plugin
    fonctionQuery query = (fonctionQuery) dlsym(handle, "query");

    if (! query) {
	cout << "Fonction \"query\" non trouve\n";
	return EXIT_FAILURE;
    }

    char *nomPlugin = query();

    cout << "Lancement du plugin " << nomPlugin << endl;

    // Lancement du plugin
    fonctionRun run = (fonctionRun) dlsym(handle, "run");

    if (! run) {
	cerr << "Fonction \"run\" non trouve\n";
	return EXIT_FAILURE;
    }

    int codeRetour = run();

    dlclose(handle);

    return codeRetour;
}
