#include <cstdlib>
#include <dlfcn.h>
#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <vector>
#include <string>
using namespace std;

#define REP_PLUGINS "plugins"
#define EXT_PLUGIN ".plg"

typedef char * (*fonctionQuery) (void);
typedef int (*fonctionRun) (void);

int
main(int argc, char *argv[]) {
    // Enregistrement des plugins
    vector<string> nomsPlugins;
    struct stat features;

    if (stat(REP_PLUGINS, &features) == -1)
	return EXIT_FAILURE;

    if (S_ISDIR(features.st_mode)) {
	DIR *dir = opendir(REP_PLUGINS);

	for (; ; ) {
	    struct dirent *file = readdir(dir);

	    if (! file)
		break;

	    if (! strcmp(file->d_name, ".") || ! strcmp(file->d_name, ".."))
		continue;

	    if (strstr(file->d_name, EXT_PLUGIN)) {
		string pluginFullFilename = REP_PLUGINS + string("/") + string(file->d_name);
		cout << "Trouv : " << pluginFullFilename << endl;
#if __GNUC__ == 3 // gcc 3.x
		void *handle = dlopen(pluginFullFilename.c_str(), RTLD_NOW | RTLD_GLOBAL);
#else
		void *handle = dlopen(pluginFullFilename.c_str(), RTLD_NOW);
#endif
		
		if (handle) {
		    fonctionQuery query = (fonctionQuery) dlsym(handle, "query");

		    if (query) {
			nomsPlugins.push_back(string(query()));
		    } else {
			cout << "Fonction \"query\" non trouve\n";
		    }

		    dlclose(handle);
		} else {
		    cerr << "Bibliothque non trouve\n";
		}
	    }
	}

	closedir(dir);
    }

    // Lancement des plugins
    for (unsigned int i = 0; i < nomsPlugins.size(); i++) {
	string nomPlugin = string(nomsPlugins[i]);
	cout << "Lancement du plugin " << nomPlugin << endl;
	string pluginFullFilename = REP_PLUGINS + string("/") + nomPlugin + string(EXT_PLUGIN);

#if __GNUC__ == 3 // gcc 3.x
	void *handle = dlopen(pluginFullFilename.c_str(), RTLD_NOW | RTLD_GLOBAL);
#else
	void *handle = dlopen(pluginFullFilename.c_str(), RTLD_NOW);
#endif
	
	if (handle) {
	    fonctionRun run = (fonctionRun) dlsym(handle, "run");

	    if (run) {
		int codeRetour = run();

		if (codeRetour != EXIT_SUCCESS)
		    cout << "Echec du lancement du plugin " << nomPlugin;
	    } else {
		cout << "Fonction \"run\" non trouve\n";
	    }

	} else {
	    cerr << "Bibliothque non trouve\n";
	}

	dlclose(handle);
    }

    return EXIT_SUCCESS;
}
